/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.corps.*;
import javax.swing.*;
import java.util.*;

/**
* This class enables you to add substances to Thermoptim's data base
* To add one substance, subclass ExtSubstance by providing the appropriate methods
* in particular, getType() must return the compressor code as it will appear in
* the substance list
*<p>This class should not be modified
 * 
 * @author Renaud GICQUEL
*/
public class CorpsExterne extends CorpsExt
{
    protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    ExtSubstance subst;
    
    public CorpsExterne(){
	    super();
    }
    
    public CorpsExterne(Object obj){
        subst=(ExtSubstance)obj;
	    setNom(subst.getType());
        setComment(subst.chemForm);
        initCorpsExt(subst.M, subst.PC, subst.TC, subst.VC, subst.Tmini, subst.Tmaxi, 
            subst.Pmini, subst.Pmaxi, subst.typeCorps);
    }

    
    
//Fonctions de calcul et d'inversion externes  Thermoptim

//doivent tre remplaces par les calculs  faire pour chaque corps

    /**
    * calcule la pression P, h et T tant donns
    * <p>
    * calculates the pressure P, h and T being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $hv double (enthalpy)
    * @param $T double (temperature)
    */
	public double getP_from_hT(double $hv,double $T){
	    return subst.getP_from_hT($hv,$T);
	}
  
    /**
    * calcule la temprature T, h et P tant donns
    * <p>
    * calculates the temperature T, h and P being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $hv double (enthalpy)
    * @param $P double (pressure)
    */
	public double getT_from_hP(double $hv,double $P){
	    return subst.getT_from_hP($hv,$P);
	}
	
	public double getT_from_hP(double $hv,double $P, double fractType, String systType, double[] fract_mol) {
        //on commence par mettre  jour la composition du systme
        subst.updateComp(systType, fractType, fract_mol);
        subst.fractType=fractType;
        return subst.getT_from_hP($hv,$P);
	}
	
    public double[] getSatComp(double T, double P, int ksat){
        return subst.getSatComp(T, P, ksat);
    }
	
	
    /**
    * renvoie le titre d'un corps pur, ou bien la composition  l'quilibre
    * <p>
    * gets the quality of a pure substance, or the composition at equilibrium
	*<p>
	* should not be overriden by ExtSubstance subclasses
    * @return double[]
    */
    public double[] getQuality(){
        return subst.getQuality();
    }
  
    public double[] getMolarWeights(){
        return subst.getMolarWeights();
    }    
  
    /**
    * calcule la pression P, s et T tant donns
    * <p>
    * calculates the pressure P, s and T being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $sv double (entropy)
    * @param $T double (temperature)
    */
	public double getP_from_sT(double $sv,double $T){
//	    System.out.println("\n subst 0 "+subst);
	    return subst.getP_from_sT($sv,$T);
	}

    /**
    * calcule la pression P, s et T tant donns
    * <p>
    * calculates the pressure P, s and T being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $sv double (entropy)
    * @param $T double (temperature)
    * @param pmin double (minimum pressure)
    * @param pmax double (maximum pressure)
    */
	public double getP_from_sT(double $sv,double $T, double pmin, double pmax){
//	    System.out.println("\n subst 0 "+subst);
	    return subst.getP_from_sT($sv, $T,  pmin,  pmax);
	}
  
    /**
    * calcule la temprature T, s et P tant donns
    * <p>
    * calculates the temperature T, s and P being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $sv double (entropy)
    * @param $P double (pressure)
    */
	public double getT_from_sP(double $sv,double $p){
	    return subst.getT_from_sP($sv,$p);
	}

	public double getT_from_sP(double $sv,double $P, double fractType, String systType, double[] fract_mol) {
        //on commence par mettre  jour la composition du systme
        subst.updateComp(systType, fractType, fract_mol);
        subst.fractType=fractType;
        return subst.getT_from_sP($sv,$P);
	}
    /**
    * calcule la temprature T, s et v tant donns
    * <p>
    * calculates the temperature T, s and v being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $sv double (entropy)
    * @param $v double (volume)
    */
	public double getT_from_sv(double $s,double $v){
	    return subst.getT_from_sv($s,$v);
	}
    
    /**
    * calcule la temprature T, u et v tant donns
    * <p>
    * calculates the temperature T, u and v being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $u double (internal energy)
    * @param $v double (volume)
    */
	public double getT_from_uv(double $u,double $v){
	    return subst.getT_from_uv($u,$v);
	}
    
    /**
    * calcule la pression P, v et T tant donns
    * <p>
    * calculates the pressure P, v and T being known
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $v double (volume)
    * @param $T double (temperature)
    */
	public double getP_from_vT(double $v,double $T){
	    return subst.getP_from_vT($v,$T);
	}

  public double[] getPTx_from_sh(double s, double h){
    return subst.getPTx_from_sh(s,h);
  }

    /**
    * calcule l'tat complet du corps pour un mlange externe
    * <p>
    * calculates the substance state for an external mixture
	*<p>
	* calculations are made in ExtSubstance subst
    * @param T double (temperature)
    * @param P double (pressure)
    * @param x double (quality)
    * @param systType String (system type)
    * @param fract_mol double[] (molar fractions)
    */
    public void CalcPropCorps (double T, double p, double x, double fractType, String systType, double[] fract_mol) {
        
        //on commence par mettre  jour la composition du systme
        subst.updateComp(systType, fractType, fract_mol);
        subst.fractType=fractType;
        double U=20., H=10., S=0.5, V=0.01, Cv=0., Xh=0.;
        
        boolean testLimits=true;
        if((T>=subst.Tmini)&&(T<=subst.Tmaxi))testLimits=true;
        else testLimits=false;
        if((subst.Tmini==0)&&(subst.Tmaxi==0))testLimits=true;//pour ne pas envoyer de message avant initialisation
        
        if(testLimits){
            //on fait appel  la mthode CalcPropCorps du mlange externe
            double[]val=subst.CalcPropCorps (T, p, x);
            //on charge les valeurs calcules
            H=val[0];
            V=val[1];
            Cv=val[2];
            x=val[3];
            U=val[4];
            S=val[5];
        }
        else{
	        String message=resIntTh_fr.getString("mess_116"); 
	        JOptionPane.showMessageDialog(new JFrame(),message);
        }
        //remise  jour des variables du corps (obfusques)
        setState(p, T, x,//en arguments
                U, H, S, V, Cv, Xh);// recalculer
    }

        
    /**
    * calcule l'tat complet du corps
    * <p>
    * calculates the substance state
	*<p>
	* calculations are made in ExtSubstance subst
    * @param T double (temperature)
    * @param P double (pressure)
    * @param x double (quality)
    */
    public void CalcPropCorps (double T, double p, double x) {
        double U=20., H=10., S=0.5, V=0.01, Cv=0., Xh=0.;
        if((T>=subst.Tmini)&&(T<=subst.Tmaxi)){
            H=subst.calcH(T,p,x);
            V=subst.calcV(T,p,x);
            Cv=subst.calcCv(T,p,x);
            x=subst.calcXx(T,p,x);
            U=subst.calcH(T,p,x);
            S=subst.calcS(T,p,x);
        }
        else{
	        String message=resIntTh_fr.getString("mess_116"); 
	        JOptionPane.showMessageDialog(new JFrame(),message);
        }
        //remise  jour des variables du corps (obfusques)
        setState(p, T, x,//en arguments
                U, H, S, V, Cv, Xh);// recalculer
	}
	
  
    /**
    * calcule la pression de saturation
    * <p>
    * calculates the saturation pressure
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param T double (temperature)
    * @param x double (quality)
    */
	public double getSatPressure(double T, double x){
	    return subst.getSatPressure(T,x);
	}
	public double getSatPressure(double T, double x, double fractType, String systType, double[] fract_mol) {
        //on commence par mettre  jour la composition du systme
        subst.updateComp(systType, fractType, fract_mol);
        subst.fractType=fractType;
        return subst.getSatPressure(T,x);
	}
	

    /**
    * calcule la temprature de saturation
    * <p>
    * calculates the saturation temperature
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param P double (pressure)
    * @param x double (quality)
    */
	public double getSatTemperature(double P, double x){
	    return subst.getSatTemperature(P,x);
	}
	public double getSatTemperature(double P, double x, double fractType, String systType, double[] fract_mol) {
        //on commence par mettre  jour la composition du systme
        subst.updateComp(systType, fractType, fract_mol);
        subst.fractType=fractType;
        return subst.getSatTemperature(P,x);
	}
    
    /**
    * calcule Cp
    * <p>
    * calculates Cp
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param Cv double (constant volume mass thermal capacity)
    */
	public double getCp(double Cv){
	    return subst.getCp(Cv);
	}
    /**
    * cette mthode calcule la viscosit dynamique liquide en Pa.s
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $T double (temprature)
    */
    public double getLiquidViscosity(double $T) {
            return subst.getLiquidViscosity( $T);
    }
    /**
    * cette mthode calcule la viscosit dynamique vapeur en Pa.s
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $T double (temprature)
    */
    public double getVaporViscosity(double $T) {
            return subst.getLiquidViscosity( $T);
    }

    /**
    * cette mthode calcule la conductivit thermique liquide en W/m/K
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $T double (temprature)
    */
    public double getLiquidConductivity(double $T) {
            return subst.getLiquidConductivity( $T);
    }
    /**
    * cette mthode calcule la conductivit thermique vapeur en W/m/K
	*<p>
	* to be overriden in ExtSubstance subclasses
    * @return double
    * @param $T double (temprature)
    */
    public double getVaporConductivity(double $T) {
            return subst.getVaporConductivity( $T);
    }  
    
    
    
}