/*
  Copyright Renaud GICQUEL 2008  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.util.*;
import rg.thopt.*;
//import sti.*;

public class ExtPilot extends rg.thopt.PilotFrame implements External
{
	Projet proj;
	String type="external component";
	
	boolean RECALCULATE=true, UPDATE_T=true, UPDATE_P=true, UPDATE_X=true,  UPDATE_ETA=true, 
	UPDATE_UA=true, UPDATE_EPSI=true,UPDATE_FLOW=true, IS_SET_FLOW=true, UPDATE_DTMIN=true, 
	UPDATE_CALC_MODE=true, DESIGN_MODE=true, OFF_DESIGN_MODE=false;
    public Vector vTechno=new Vector();
	String technoDesignData="";
	
	public ExtPilot()
	{
		//{{INIT_CONTROLS
		setTitle("pilot");
		getContentPane().setLayout(null);
		setSize(642,459);
		setVisible(false);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		//}}

		//{{INIT_MENUS
		//}}
	}

	public ExtPilot(Projet proj)
	{
		this();
		this.proj=proj;
		setupProject();
		
		if(isBuilt)show();
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
        for(int i=0;i<listComp.length;i++){
        }
	}
	
    /**
    * returns the component type 
    **/
    public String getType(){
        return type;
    }
    /**
    * returns the class type 
    **/
    public String getClassType(){
        return "pilot";
    }
    
    /**
    * returns the process mass flow 
    **/
    public double getProcessFlow(String name){
        String[] args=new String[2];
        args[0]="process";
        args[1]=name;
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        return f.doubleValue();
    }
    
	
    /**
    * returns the class description 
    **/
	public String getClassDescription(){
	    return "external pilot class\nbasic generic class";
	}
	
    public void init(){}
	boolean isBuilt=false;
	String[]composant,nomComposant,nomNozz;
    String nomComb="",nomCompr="",nomDiff="";
    void setupProject(){}
    
   /**
	* Met  jour les proprits d'une transfo dans Thermoptim
    *<p>
	* Updates process properties in Thermoptim
	*<p>
	* not to be overriden by ExtPilot subclasses
	*/
    public void updateprocess(String name, String type, boolean recalculate, boolean isSetFlow, boolean updateFlow, double flow,  
        boolean updateParam1, double param1){
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(type);
         vPoint.addElement(Util.aff_b(updateFlow));
         vPoint.addElement(new Double(flow));
         vPoint.addElement(Util.aff_b(recalculate));
         vPoint.addElement(Util.aff_b(isSetFlow));
         vPoint.addElement(Util.aff_b(updateParam1));
         vPoint.addElement(new Double(param1)); 
         proj.updateProcess(vPoint);
	
	    }
    /**
	* Met  jour les proprits d'une transfo dans Thermoptim
    *<p>
	* Updates process properties in Thermoptim
	*<p>
	* not to be overriden by ExtPilot subclasses
	*/
   public void updateprocess(String name, String type, boolean recalculate, boolean isSetFlow, boolean updateFlow, double flow,  
        boolean updateParam1, double param1, boolean updateParam2, double param2){
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(type);
         vPoint.addElement(Util.aff_b(updateFlow));
         vPoint.addElement(new Double(flow));
         vPoint.addElement(Util.aff_b(recalculate));
         vPoint.addElement(Util.aff_b(isSetFlow));
         vPoint.addElement(Util.aff_b(updateParam1));
         vPoint.addElement(new Double(param1));
         vPoint.addElement(Util.aff_b(updateParam2));
         vPoint.addElement(new Double(param2));
         proj.updateProcess(vPoint);
	
	    }
    /**
	* Met  jour les proprits d'une transfo dans Thermoptim
    *<p>
	* Updates process properties in Thermoptim
	*<p>
	* not to be overriden by ExtPilot subclasses
	*/
   public void updateprocess(String name, String type, boolean recalculate, boolean isSetFlow, boolean updateFlow, double flow,  
        boolean updateParam1, double param1, boolean updateParam2, double param2, boolean updateParam3, double param3){
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(type);
         vPoint.addElement(Util.aff_b(updateFlow));
         vPoint.addElement(new Double(flow));
         vPoint.addElement(Util.aff_b(recalculate));
         vPoint.addElement(Util.aff_b(isSetFlow));
         vPoint.addElement(Util.aff_b(updateParam1));
         vPoint.addElement(new Double(param1));
         vPoint.addElement(Util.aff_b(updateParam2));
         vPoint.addElement(new Double(param2));
         vPoint.addElement(Util.aff_b(updateParam3));
         vPoint.addElement(new Double(param3));
         proj.updateProcess(vPoint);
	
	    }
	    
	 
	/**
	* Met  jour les proprits d'un changeur de chaleur dans Thermoptim
    *<p>
	* Updates heat exchanger properties in Thermoptim
	*<p>
	* not to be overriden by ExtPilot subclasses
	*/
    public void updateHx(String name, boolean recalculate, boolean updateUA, double UA,  
        boolean updateEpsi, double epsi, boolean updateDTmin, double DTmin, boolean updateCalcMode, boolean calcMode){
         Vector vPoint=new Vector();
         vPoint.addElement(name);// [0]
         vPoint.addElement(Util.aff_b(recalculate));// [1]
         vPoint.addElement(Util.aff_b(updateUA));// [2]
         vPoint.addElement(new Double(UA));// [3]
         vPoint.addElement(Util.aff_b(updateEpsi));// [4]
         vPoint.addElement(new Double(epsi));// [5]
         vPoint.addElement(Util.aff_b(updateDTmin));// [6]
         vPoint.addElement(new Double(DTmin));// [7]
         vPoint.addElement(Util.aff_b(updateCalcMode));// [8]
         vPoint.addElement(Util.aff_b(calcMode));// [9]
         proj.updateHX(vPoint);
	
	 }
	/**
	* Met  jour les proprits d'un changeur de chaleur dans Thermoptim
    *<p>
	* Updates heat exchanger properties in Thermoptim
	*<p>
	* not to be overriden by ExtPilot subclasses
	*/
	    public void updateHx(String name, boolean recalculate, boolean updateUA, double UA,  
        boolean updateEpsi, double epsi, boolean updateDTmin, double DTmin){
            updateHx(name, recalculate, updateUA, UA, updateEpsi, epsi, updateDTmin, DTmin, false, true);
        }
	 
	   /**
	* Met  jour les proprits d'un noeud dans Thermoptim
    *<p>
	* Updates node properties in Thermoptim
	*<p>
	* not to be overriden by ExtPilot subclasses
	 */
    public void updateNode(String name, boolean recalculate, boolean updateEfficiency, double epsi){
         Vector vPoint=new Vector();
         vPoint.addElement(name);// [0]
         vPoint.addElement(Util.aff_b(recalculate));// [1]
         vPoint.addElement(Util.aff_b(updateEfficiency));// [2]
         vPoint.addElement(new Double(epsi));// [3]
         proj.updateNode(vPoint);
	
	 }
	 

    public void updateSetPressure(String name, double value){
         Vector vPoint=new Vector();
         vPoint.addElement(name);// [0]
         vPoint.addElement(new Double(value));// [1]
       proj.updateSetPressure(vPoint);
	
	 }
	
	 

	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == ExtPilot.this)
			ExtPilot_WindowClosing(event);
		}
	}

	void ExtPilot_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
		}
	}
	


	

}