/*
Copyright Renaud GICQUEL 2005  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import rg.corps.*; 
import rg.thopt.*;
import javax.swing.*;

/**
* This class enables you to add external components to Thermoptim.
*<p>
* To add one component, subclass ExtProcess by providing the appropriate methods
* in particular, getType() must return the component type as it will appear in
* the process list.
*<p>This class should not be modified
 * 
 * @author Renaud GICQUEL
*/
public class ExtProcess implements External
{
    double Tpoint,Ppoint,Xpoint,Vpoint,Upoint,Hpoint,Spoint,DTsatpoint,corrFactorpoint;
    Corps lecorps;
    String nomCorps,presSetNamepoint="";
    boolean isTsatSet,isPsatSet;
	double Wpoint,Epsipoint,QPrimepoint,Tprimepoint,Trpoint,VPrimepoint,Condpoint, M_secpoint;
 	protected  String tab=new String("\t");
	protected  String ligne=new String("\n");
    TransfExterne tfe;
    Projet proj;
    double Tamont,Pamont,Vamont,flow;
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	String type="external component";
	double M_H2O = 18.01528;
	
	public String[]thermoCouplerTypes={"basic external coupler"};
	
	double tauPlus,deltaXhPlus,xqPlus,tauProduct,deltaXhProduct,etaExer,deltaXhi;
    String exergyType="not defined";
    public ExtProcess (){
        super();
    }
    /**
    * dfinit l'identifiant de la classe
    * <p>
    * defines the class identifier
    * <p>
    * must be overridden by subclasses
    */
    public String getType(){
        return type;
    }
    /**
    * returns the class type 
	*<p>
	* not to be overriden by ExtProcess subclasses
    **/
    public String getClassType(){
        return "process";
    }
    /**
    * dfinit la description de la classe apparaissant dans le visualisateur
    * <p>
    * defines the class description shown in the viewer
    * <p>
    * should be overridden by subclasses
    */
	public String getClassDescription(){
	    return "external process class\nbasic generic class";
	}
	/**
	* returns Thermoptim's process name
	*/
    public String getName(){
        return tfe.getCompName();
    }
	/**
	* returns Tthe process mass flow rate
	*/
    public double getFlow(){
        return flow;
    }
	
	/**
	* used for productive structures
	*/
	void setExergyExtensor(boolean isExtensor){
	    if(isExtensor)exergyType="extensor";
	    else exergyType="reductor";
	}
	/**
	* used for productive structures
	*/
   public String[] getExergyType(){//modRG exerg
        String[] type=new String[9];
        type[0]=exergyType;//extensor ou reductor
        type[1]="false";//affiche JCheckExtSource
        type[2]="External source";//label JCheckExtSource
        type[3]="false";//affiche JCheckIntExchange
        type[4]="Internal exchange";//label JCheckIntExchange
        type[5]="false";//affiche JCheckValuableExergy
        type[6]="Valuable exergy";//label JCheckValuableExergy
        type[7]="false";//affiche champ d'entre de valeur
        type[8]="Source T (C)";//label sourceT_value
        return type;
    }
	/**
	* used for productive structures
	*/
    public double[] getExergyBalance(String[]args){//modRG exerg
        double[] exergyBalance=new double[7];
        exergyBalance[0]=tauPlus;
        exergyBalance[1]=deltaXhPlus;
        exergyBalance[2]=xqPlus;
        exergyBalance[3]=tauProduct;
        exergyBalance[4]=deltaXhProduct;
        exergyBalance[5]=etaExer;
        exergyBalance[6]=deltaXhi;
        if(exergyType.equals("not defined")){
	        String message="Watch out! Component "+tfe.getName()+" exergy balance is not implemented"; 
	        JOptionPane.showMessageDialog(new JFrame(),message);
            
        }
        return exergyBalance;
    }
	
    public boolean arePortsVisible(){
        return true;
    }
	
    public void init(){}
	
	/**
	* calcule la transfo
	*<p>
	* calculates the process
	*<p>
	* to be overriden in ExtProcess subclasses
	**/
	public void calculateProcess(){}

	/**
	* Charge l'tat thermodynamique d'un point dans un Vector
	*<p>
	* Loads the thermodynamic state of a point in a Vector
	*<p>
	* not to be overriden by ExtProcess subclasses
	*
	*/
	public Vector getProperties(){
	    Vector vProp=new Vector();
	    vProp.addElement(lecorps);//Corps
	    vProp.addElement(nomCorps);//Corps
	    vProp.addElement(new Double(Tpoint));
	    vProp.addElement(new Double(Ppoint));
	    vProp.addElement(new Double(Xpoint));
	    vProp.addElement(new Double(Vpoint));
	    vProp.addElement(new Double(Upoint));
	    vProp.addElement(new Double(Hpoint));
	    vProp.addElement(new Double(Spoint));
	    return vProp;
	}
	/**
	* Charge les nergies mises en jeu dans un Vector
	*<p>
	* Loads the energy values in a Vector
	*<p>
	* not to be overriden by ExtProcess subclasses
	*
	*/
    public Vector setEnergyTypes(String process, double useful,double purchased, double other){
	    Vector vEner=new Vector();
	    vEner.addElement(process);//process name
	    vEner.addElement(new Double(useful));//useful energy
	    vEner.addElement(new Double(purchased));//purchased energy
	    vEner.addElement(new Double(other));//other energy
	    return vEner;
    }

    /**
	* Met  jour les proprits d'un point dans Thermoptim
    *<p>
	* Updates a point's properties in Thermoptim
	*<p>
	* not to be overriden by ExtProcess subclasses
	*/
    public void updatepoint(String name, boolean updateT, double T,  
        boolean updateP, double P, boolean updateX, double x,
        boolean melHum, String task, double value){
	    updatepoint(name, updateT, T, updateP, P, updateX, x, melHum, task, value, false, 1.);
	
	    }
    public void updatepoint(String name, boolean updateT, double T,  
        boolean updateP, double P, boolean updateX, double x,
        boolean melHum, String task, double value, boolean updateCorrFactor, double corrFactor){
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(Util.aff_b(updateT));
         vPoint.addElement(Util.aff_d(T));
         vPoint.addElement(Util.aff_b(updateP));
         vPoint.addElement(Util.aff_d(P));
         vPoint.addElement(Util.aff_b(updateX));
         vPoint.addElement(Util.aff_d(x));
         vPoint.addElement(Util.aff_b(melHum));
         vPoint.addElement(task);
         vPoint.addElement(Util.aff_d(value));
         vPoint.addElement(Util.aff_b(updateCorrFactor));
         vPoint.addElement(Util.aff_d(corrFactor));
         proj.updatePoint(vPoint);
	
	    }
    
   /**
	* Met  jour les proprits d'une transfo dans Thermoptim
    *<p>
	* Updates process properties in Thermoptim
	*<p>
	* not to be overriden by ExtProcess subclasses
	*/
    public void updateprocess(String name, String type, boolean recalculate, boolean isSetFlow, boolean updateFlow, double flow,  
        boolean updateParam1, double param1){
	    String[] args=new String[2];
         Vector vPoint=new Vector();
         vPoint.addElement(name);
         vPoint.addElement(type);
         vPoint.addElement(Util.aff_b(updateFlow));
         vPoint.addElement(new Double(flow));
         vPoint.addElement(Util.aff_b(recalculate));
         vPoint.addElement(Util.aff_b(isSetFlow));
         vPoint.addElement(Util.aff_b(updateParam1));
         vPoint.addElement(new Double(param1));
         proj.updateProcess(vPoint);
	
	    }

	/**
	* lit les paramtres de la transfo
	*<p>
	* reads the process parameters
    * @param ligne_data String (data line)
	*<p>
	* to be overriden in ExtProcess subclasses
	**/
	public void readCompParameters(String ligne_data){}
	
	/**
	* sauve les paramtres de la transfo
	*<p>
	* saves the process parameters
    * @return String
	*<p>
	* to be overriden in ExtProcess subclasses
	**/
    public String saveCompParameters(){return "";}



    /**
	* Rcupre les proprits d'un point
    *<p>
	* Gets a point's properties
	*<p>
	* not to be overriden by ExtProcess subclasses
	*/
    public void getPointProperties(String nom){
	    String[] args=new String[2];
	    args[0]="point";//type of the element (see method getProperties(String[] args))
	    args[1]=nom;//name of the process (see method getProperties(String[] args))
	    Vector vProp=proj.getProperties(args);
        lecorps=(Corps)vProp.elementAt(0);
        nomCorps=(String)vProp.elementAt(1);
        Double y=(Double)vProp.elementAt(2);
        Tpoint=y.doubleValue();
        y=(Double)vProp.elementAt(3);
	    Ppoint=y.doubleValue();
        y=(Double)vProp.elementAt(4);
	    Xpoint=y.doubleValue();
        y=(Double)vProp.elementAt(5);
	    Vpoint=y.doubleValue();
        y=(Double)vProp.elementAt(6);
	    Upoint=y.doubleValue();
        y=(Double)vProp.elementAt(7);
	    Hpoint=y.doubleValue();
        y=(Double)vProp.elementAt(8);
	    Spoint=y.doubleValue();
        y=(Double)vProp.elementAt(10);
	    DTsatpoint=y.doubleValue();
	    String dum=(String)vProp.elementAt(9);
	    isTsatSet=Util.lit_b(Util.extr_value(dum));
	    dum=(String)vProp.elementAt(11);
	    isPsatSet=Util.lit_b(Util.extr_value(dum));//*/
	    
	    y=(Double)vProp.elementAt(12);
	    Wpoint=y.doubleValue();
	    y=(Double)vProp.elementAt(13);
	    Epsipoint=y.doubleValue();
	    y=(Double)vProp.elementAt(14);
	    QPrimepoint=y.doubleValue();
	    y=(Double)vProp.elementAt(15);
	    Tprimepoint=y.doubleValue();
	    y=(Double)vProp.elementAt(16);
	    Trpoint=y.doubleValue();
	    y=(Double)vProp.elementAt(17);
	    VPrimepoint=y.doubleValue();
	    y=(Double)vProp.elementAt(18);
	    Condpoint=y.doubleValue();
	    y=(Double)vProp.elementAt(19);
	    M_secpoint=y.doubleValue();
	    if(vProp.size()>20){
	        presSetNamepoint=(String)vProp.elementAt(22);
	        y=(Double)vProp.elementAt(23);
	        corrFactorpoint=y.doubleValue();
	    }

    }
    
    double Tsubst,Psubst,Xsubst,Vsubst,Usubst,Hsubst,Ssubst,Msubst;
    int typeSubst;
	/**
	* Rcupre les proprits d'un corps
    *<p>
	* Gets a substance's properties
	*<p>
	* not to be overriden by ExtProcess subclasses
	*/
    public void getSubstProperties(String nom){
	    String[] args=new String[2];
	    args[0]="subst";//type of the element (see method getProperties(String[] args))
	    args[1]=nom;//name of the process (see method getProperties(String[] args))
	    Vector vProp=proj.getProperties(args);
        Double y=(Double)vProp.elementAt(0);
        Tsubst=y.doubleValue();
        y=(Double)vProp.elementAt(1);
	    Psubst=y.doubleValue();
        y=(Double)vProp.elementAt(2);
	    Xsubst=y.doubleValue();
        y=(Double)vProp.elementAt(3);
	    Vsubst=y.doubleValue();
        y=(Double)vProp.elementAt(4);
	    Usubst=y.doubleValue();
        y=(Double)vProp.elementAt(5);
	    Hsubst=y.doubleValue();
        y=(Double)vProp.elementAt(6);
	    Ssubst=y.doubleValue();
        y=(Double)vProp.elementAt(7);
        Msubst=y.doubleValue();
        Integer i=(Integer)vProp.elementAt(8);
        typeSubst=i.intValue();
    }


	/**
	* Met  jour le thermocoupleur du type donn
    *<p>
	* Updates the thermocoupler of the type given
	*<p>
	* not to be overriden by ExtProcess subclasses
    * @param type String (thermocoupler ID)
    * @param Tin double (inlet temperature)
    * @param Tout double (outlet temperature)
    * @param Q double (heat load)
    * @param flow double (mass flow rate)
	*/
    protected void updateThermoCoupler(String type, double Tin, double Tout, double Q, double flow){
        tfe.te.updateThermoCouplers(getThermoCouplerVector(type, Tin, Tout, Q, flow));
    }
	/**
	* Met  jour le thermocoupleur du type donn
    *<p>
	* Updates the thermocoupler of the type given
	*<p>
	* not to be overriden by ExtProcess subclasses
    * @param type String (thermocoupler ID)
    * @param Tin double (inlet temperature)
    * @param Tout double (outlet temperature)
    * @param Q double (heat load)
    * @param flow double (mass flow rate)
    * @param isPinchFluid boolean (true if to be taken into account in optimization method)
    * @param DTmin double (pinch value)
	*/
    protected void updateThermoCoupler(String type, double Tin, double Tout, double Q, double flow, boolean isPinchFluid, double DTmin){
        tfe.te.updateThermoCouplers(getThermoCouplerVector(type, Tin, Tout, Q, flow));
    }
	
	/**
	* Construit le Vector de mise  jour du thermocoupleur du type donn
    *<p>
	* Builds the Vector for updating the thermocoupler of the type given
	*/
    protected Vector getThermoCouplerVector(String type, double Tin, double Tout, double Q, double flow){
        Vector vTC=new Vector();
        vTC.addElement(type);
        Double d=new Double(Tin);
        vTC.addElement(d);
        d=new Double(Tout);
        vTC.addElement(d);
        d=new Double(Q);
        vTC.addElement(d);
        d=new Double(flow);
        vTC.addElement(d);
        return vTC;
    }
	/**
	* Construit le Vector de mise  jour du thermocoupleur du type donn
    *<p>
	* Builds the Vector for updating the thermocoupler of the type given
	*/
    protected Vector getThermoCouplerVector(String type, double Tin, double Tout, double Q, double flow, boolean isPinchFluid, double DTmin){
        Vector vTC=new Vector();
        vTC.addElement(type);
        Double d=new Double(Tin);
        vTC.addElement(d);
        d=new Double(Tout);
        vTC.addElement(d);
        d=new Double(Q);
        vTC.addElement(d);
        d=new Double(flow);
        vTC.addElement(d);
        Boolean b=new Boolean(isPinchFluid);
        vTC.addElement(b);
        d=new Double(DTmin);
        vTC.addElement(d);
        return vTC;
    }
	
 /*   public void updateThermoCouplers(Vector vTC){
        String thermoCoupler=(String)vTC.elementAt(0);
        Double y=(Double)vTC.elementAt(1);
        double Tin=y.doubleValue();
        y=(Double)vTC.elementAt(2);
        double Tout=y.doubleValue();
        y=(Double)vTC.elementAt(3);
        double Qload=y.doubleValue();
        y=(Double)vTC.elementAt(4);
        double flow=y.doubleValue();
        int k=-1;
        for(int i=0;i<thermoCouplerTypes.length;i++){
            if(thermoCouplerTypes[i].equals(thermoCoupler)){
                k=i;
                break;
            }
        }
        transferredHeat[k]=Qload;
    }
	*/
	
	/**
	* Imprime la valeur de UA du thermocoupleur du type donn
    *<p>
	* Prints the UA value of the thermocoupler of the type given
    * <p>
    * not to be overridden by subclasses
    * @param type String (thermocoupler ID)
	*/
	protected void getUA(String type){
        Vector vAbs=tfe.te.getThermoCouplerData(type);
        String nomAbs=(String)vAbs.elementAt(0);
	    
	    if((nomAbs!=null)&&(!nomAbs.equals(""))&&(!nomAbs.equals("null"))){
		    String[] args=new String[2];
		    args[0]="heatEx";//type of the element (see method getProperties(String[] args))
		    args[1]=nomAbs;//name of the process (see method getProperties(String[] args))
		    Vector vProp=proj.getProperties(args);
	        String nomExch=(String)vProp.elementAt(0);//15
		    Double f=(Double)vProp.elementAt(15);
		    double UA=f.doubleValue();
	        System.out.println(" nom "+type+ " : "+nomAbs+"  UA : "+UA);
	    }
	    
	}
	
    double f_dicho(double X, double T,String fonc){
        return 0;
    }

}